﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Drawing;
using System.Drawing.Imaging;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Thumbnailstitcher
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }



        private void button1_Click_1(object sender, EventArgs e)
        {
            moviepathFileDialog.ShowDialog();
            filename.Text = moviepathFileDialog.FileName;
        }

        private void browse_thumb_Click(object sender, EventArgs e)
        {
            resultFileDialog.ShowDialog();
            result.Text = resultFileDialog.FileName;
        }

        private void generate_Click(object sender, EventArgs e)
        {
            // http://superuser.com/questions/538112/meaningful-thumbnails-for-a-video-using-ffmpeg
            /*
            for X in 1..N
                T = integer( (X - 0.5) * D / N )  
                run `ffmpeg -ss <T> -i <movie>
                    -vf select="eq(pict_type\,I)" -vframes 1 image<X>.jpg`
            */
            Process proc = new Process();
            proc.StartInfo.RedirectStandardError = true;
            proc.StartInfo.FileName = "ffmpeg";
            proc.StartInfo.Arguments = "-y -i \"" + filename.Text + "\"";
            proc.StartInfo.UseShellExecute = false;
            proc.StartInfo.CreateNoWindow = true;
            proc.Start();
            proc.WaitForExit();
            string s=proc.StandardError.ReadToEnd();
            Match dur = new Regex("Duration: (\\d+):(\\d{2}):(\\d{2}).(\\d+)").Match(s);
            if (!dur.Success)
            {
                throw new Exception("Error determining duration");
            }
            Match ar = new Regex("DAR (\\d+):(\\d+)").Match(s);
            double aspect_ratio = Double.Parse(ar.Groups[1].Value) / Double.Parse(ar.Groups[2].Value);
            
            int x = decimal.ToInt32(X.Value);
            int y = decimal.ToInt32(Y.Value);
            int n = x * y;

            int picwidth = decimal.ToInt32(pixelwidth.Value);
            int picheight = (int)(picwidth / aspect_ratio/x*y);
            int thumbwidth = picwidth / x;
            int thumbheight = picheight / y;
            
            long durins = Int32.Parse(dur.Groups[1].Value) * 3600 + Int32.Parse(dur.Groups[2].Value) * 60 + Int32.Parse(dur.Groups[3].Value);

            Bitmap data = new Bitmap(picwidth, picheight);
            for(int i = 0; i < x; ++i)
            {
                for (int j = 0; j < y; ++j)
                {
                    Process ffmpeg = new Process();
                    ffmpeg.StartInfo.RedirectStandardOutput = true;
                    ffmpeg.StartInfo.UseShellExecute = false;
                    ffmpeg.StartInfo.CreateNoWindow = true;
                    ffmpeg.StartInfo.FileName = "ffmpeg";
                    ffmpeg.StartInfo.Arguments = "-ss " + (int)((i * x + j + 0.5) * durins / n) + " -i \"" + filename.Text +
                        "\" -vf select=\"eq(pict_type\\,I)\" -vframes 1 -f rawvideo -vcodec rawvideo -pix_fmt bgr24 -s " +
                        thumbwidth + "x" + thumbheight +
                        " -";

                    ffmpeg.Start();
                    byte[] pic = new byte[thumbwidth * thumbheight * 3];
                    int read = 0;
                    while (read < thumbwidth * thumbheight * 3)
                    {
                        int val = ffmpeg.StandardOutput.BaseStream.Read(pic, read, thumbwidth * thumbheight * 3-read);
                        read += val;
                    }
                    BitmapData bd=data.LockBits(
                        new Rectangle(j * thumbwidth, i * thumbheight, thumbwidth, thumbheight), 
                        System.Drawing.Imaging.ImageLockMode.WriteOnly, System.Drawing.Imaging.PixelFormat.Format24bppRgb);
                    for (int k = 0; k < thumbheight; ++k)
                        System.Runtime.InteropServices.Marshal.Copy(pic, k * thumbwidth*3, bd.Scan0 + k * bd.Stride, thumbwidth*3);
                    data.UnlockBits(bd);
                }
            }
            data.Save(result.Text);
        }
    }
}
